# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without mead

%if %with mead
%bcond_with repolib
%else
%bcond_without repolib
%endif

%define section free
%define reltag .GA_redhat_2
%define namedreltag .GA-redhat-2
%global namedversion %{version}%{?namedreltag}

%define maven_version 2.0.3.GA-redhat-2

Name:           jbossxb2
Version:        2.0.3
Release:        13%{?reltag}%{?dist}.3
Epoch:          0
Summary:        JBoss XB
License:        LGPLv2+
Group:          Development/Java

%if %with mead
Source100: org.jboss-jbossxb-2.0.3.GA-redhat-2-sources.zip
Source101: org.jboss-jbossxb-2.0.3.GA-redhat-2-patches.zip
Source102: jbossxb-2.0.3.GA-redhat-2.jar
Source103: jbossxb-2.0.3.GA-redhat-2-sources.jar
Source104: jbossxb-2.0.3.GA-redhat-2-javadoc.jar
Source105: jbossxb-2.0.3.GA-redhat-2.pom
%endif

URL:            http://www.jboss.org/
%if 0
rm -rf jbossxb2-2.0.3 && svn -q export -r 4884 http://anonsvn.jboss.org/repos/common/jbossxb/tags/2.0.3.GA jbossxb2-2.0.3 && tar cjf jbossxb2-2.0.3.tar.bz2 jbossxb2-2.0.3
%endif
%if %without mead
Source0:        jbossxb2-2.0.3.tar.bz2
Patch0:         jbossxb2-vman-pom.patch
%endif
Obsoletes:      jbossxb < %{epoch}:%{version}-%{release}
Provides:       jbossxb = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
Requires:       jaxb_api
Requires:       jboss-common-core
Requires:       jboss-logging
Requires:       xerces-j2
%if 0
# XXX: in pom, but I guess optional
Requires:       dtdparser
Requires:       jboss-reflect
%endif
%if %without mead
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-surefire-provider-junit4
# XXX: we're using a patch instead
%if 0
BuildRequires:  dtdparser
BuildRequires:  eap5-boms
BuildRequires:  pom-version-manipulator
%endif
BuildRequires:  jboss-common-core
BuildRequires:  jboss-jaxb-api_2.2_spec
BuildRequires:  jboss-logging
BuildRequires:  jboss-parent
BuildRequires:  jboss-reflect
BuildRequires:  jboss-specs-parent
BuildRequires:  jboss-test
BuildRequires:  junit4
BuildRequires:  xerces-j2
%else
BuildRequires:  unzip
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss XB.

%package javadoc
Summary:        Javadoc for jbossxb
Group:          Development/Documentation

Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%if %without mead
%setup -q -n jbossxb2-%{version}
%patch0 -p1 -b .sav0
%if 0
# XXX: we're using a patch instead
# Adjust pom.xml
%{_bindir}/modpom pom.xml %{_javadir}/jbossas/jboss-as-component-matrix.pom
%{__mv} jbossxb-2.0.1.GA.pom pom.xml
%endif
%endif

%build
%if %without mead
export LC_ALL=en_US.UTF8
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
export MAVEN_OPTS="-Xms1g -Xmx1g -XX:MaxPermSize=512M -Dproject.build.sourceEncoding=UTF8"
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} javadoc:aggregate javadoc:aggregate-jar deploy
%endif

%install
%{__rm} -rf %{buildroot}

%{__mkdir_p} %{buildroot}%{_javadir}
%if %without mead
#%{__cp} -p maven2-brew/org/jboss/jbossxb/%{namedversion}/jbossxb-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/jbossxb-%{namedversion}-javadoc.jar
%{__cp} -p maven2-brew/org/jboss/jbossxb/%{namedversion}/jbossxb-%{namedversion}-sources.jar %{buildroot}%{_javadir}/jbossxb-%{namedversion}-sources.jar
%{__cp} -p maven2-brew/org/jboss/jbossxb/%{namedversion}/jbossxb-%{namedversion}.jar %{buildroot}%{_javadir}/jbossxb-%{namedversion}.jar
%else
#%{__cp} -p %{_sourcedir}/jbossxb-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/jbossxb-%{namedversion}-javadoc.jar
%{__cp} -p %{_sourcedir}/jbossxb-%{namedversion}-sources.jar %{buildroot}%{_javadir}/jbossxb-%{namedversion}-sources.jar
%{__cp} -p %{_sourcedir}/jbossxb-%{namedversion}.jar %{buildroot}%{_javadir}/jbossxb-%{namedversion}.jar
%endif
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%if %without mead
%{__cp} -p maven2-brew/org/jboss/jbossxb/%{namedversion}/jbossxb-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-jbossxb.pom
%else
%{__cp} -p %{_sourcedir}/jbossxb-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-jbossxb.pom
%endif

# depmaps
%add_to_maven_depmap org.jboss jbossxb %{namedversion} JPP jbossxb
[ -f %{buildroot}%{_mavendepmapfragdir}/jbossxb ] || %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/jbossxb

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/jbossxb-%{namedversion}
%if %without mead
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/jbossxb-%{namedversion}
%else
%{_bindir}/unzip -qq %{_sourcedir}/jbossxb-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/jbossxb-%{namedversion}
%{__rm} -r %{buildroot}%{_javadocdir}/jbossxb-%{namedversion}/META-INF
%endif
%{__ln_s} jbossxb-%{namedversion} %{buildroot}%{_javadocdir}/jbossxb

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
#%{_javadir}*/jbossxb-%{namedversion}-javadoc.jar
#%{_javadir}*/jbossxb-javadoc.jar
%{_javadir}*/jbossxb-%{namedversion}-sources.jar
%{_javadir}*/jbossxb-sources.jar
%{_javadir}*/jbossxb-%{namedversion}.jar
%{_javadir}*/jbossxb.jar
%{_mavenpomdir}/JPP-jbossxb.pom
%{_mavendepmapfragdir}/jbossxb

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/jbossxb-%{namedversion}
%{_javadocdir}/jbossxb

%if %without mead
%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif
%endif

%changelog
* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.0.3-13.GA_redhat_2.3
- Rebuild for MD5

* Mon Aug 20 2012 Paul Gier <pgier@redhat.com> - 0:2.0.3-12.GA_redhat_2.3
- Update pom patch for eap 6.0.1

* Sun Aug 12 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.0.3-12.GA_redhat_2.2
- Rebuild unsigned

* Thu Jul 12 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.0.3-12.GA_redhat_1.1
- Rebuild using cache signing

* Thu May 31 2012 Martha Benitez <mbenitez@redhat.com> - 0:2.0.3-12.GA_redhat_1
- Remove javadocs from main package

* Thu May 10 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.0.3-11.GA_redhat_1
- Populate java-signed

* Wed May 02 2012 David Walluck <dwalluck@redhat.com> 0:2.0.3-10
- fix jaxb requires
- fix javadoc install

* Thu Apr 12 2012 Lin Gao <lgao@redhat.com> - 0:2.0.3-9.GA_redhat_1
- Re vman for the patch to import BOMs

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.0.3-8.GA_redhat_1.1
- Rebuild using cache signing

* Wed Feb 08 2012 David Walluck <dwalluck@redhat.com> 0:2.0.3-8
- build in non-mead mode
- remove activation from pom (in JRE)
- remove xml-apis from pom (in JRE)
- remove dtdparser requires (mark as provided)
- remove jboss-relect requires (mark as provided)
- add xerces-j2 requires
- replace jboss-common-logging-spi with jboss-logging
- fix repolib install
- fix javadoc dir named and version
- use javadoc jar in MEAD mode
- fix duplicate dir onwership
- fix repolib file ownership
- fix jar locations
- fix jar names

* Tue Feb 07 2012 Red Hat Release Engineering <release-engineering@redhat.com> - 0:2.0.3-7
- Rebuild to use new signing key

* Fri Feb 03 2012 Fernando nasser <fnasser@redhat.com> - 0:2.0.3-6
- Move JAXB API to 2.2

* Thu Feb 02 2012 Martha Benitez <mbenitez@redhat.com> - 0:2.0.3-5
- Install javadoc, sources and versioned jars

* Thu Feb 02 2012 Martha Benitez <mbenitez@redhat.com> - 0:2.0.3-4
- Build RPM wrapper

* Mon Nov 07 2011 Lin Gao <lgao@redhat.com> - 0:2.0.3-3
- fix patch
- add javadoc:jar in mead.sh goal

* Wed Oct 26 2011 Permaine Cheung <pcheung@redhat.com> - 0:2.0.3-1
- 2.0.3.GA

* Thu Jan 20 2011 Yiqiao Wang <yiwang@redhat.com> - 0:2.0.1-8
- Add BR codehaus-stax11-api
- Modify jbossxb2-pom.patch to change jaxb-api's groupId to javax.xml.bind

* Thu Jan 20 2011 Yiqiao Wang <yiwang@redhat.com> - 0:2.0.1-7
- Modify jbossxb2-pom.patch to change xercesImpl's groupId to xerces
- Add BR eap5-boms, pom-version-manipulator to adjust pom.xml

* Fri Dec 3 2010 Yiqiao Wang <yiwang@redhat.com> - 0:2.0.1-6
- Build with Maven 2.2.1
- Add upload.sh to repolib
- Fix %%files for signed jars
- Add content of maven2-brew, add BR maven-deploy-plugin
- Add the line to find and remove any binaries
- Change BR maven-release to maven-release-plugin

* Thu Jul 29 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.0.1-5
- Add Obsoletes jbossxb

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.0.1-4.1
- rebuilt

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redha.com> 0:2.0.1-4
- Rebuild

* Wed Feb 10 2010 Fernando Nasser <fnasser@redhat.com> 0:2.0.1-3
- Remove 121 from dtdparser artifact name
- Add POM to repolib

* Thu Jan 28 2010 Yiqiao Wang <yiwang@redhat.com> 0:2.0.1-2.1.1
- Removed the patch to rebuild with dependecy to jboss-test. 

* Fri Jan 15 2010 Yiqiao Wang <yiwang@redhat.com> 0:2.0.1-2.1
Add patches to remove need for jboss-test

* Thu Jun 18 2009 David Walluck <dwalluck@redhat.com> 0:2.0.1-2
- add repolib
- install symlink to upstream name
- install into %%{_javadir} instead of %%{_javadir}/jboss

* Tue Jun 09 2009 Ralph Apel <r.apel@r-apel.de> - 0:2.0.1-1.jpp5
- 2.0.1.GA 

* Mon Jun 01 2009 Ralph Apel <r.apel@r-apel.de> - 0:2.0.0-1.jpp5
- 2.0.0.GA as jbossxb2
